package com.agiledeveloper;

public class ScoreStore
{
    private IRepository _repository;

    public ScoreStore(IRepository repository)
    {
        _repository = repository;
    }

    public void update(String playerName, int attempts)
    {
        int playCount = getPlayCount(playerName);
        int best = getBestScore(playerName);
        int worst = getWorstScore(playerName);

        if (attempts < best) best = attempts;
        if (worst < attempts) worst = attempts;

        _repository.set(playerName, playCount + 1, best, worst);
    }

    public int getPlayCount(String playerName)
    {
        return _repository.getPlayCount(playerName);
    }

    public int getBestScore(String playerName)
    {
        return _repository.getBestScore(playerName);
    }

    public int getWorstScore(String playerName)
    {
        return _repository.getWorstScore(playerName);
    }
}
